`timescale 1 ns/1 ns

module test_icore_std();

    `include "F:/svn/robot_project/trunk/code/STM32/reg_addr.v"
    
    parameter FINISH_TIME  = 100000;

    parameter FRAME_NUM  = 1;
    parameter IMG_LEN  =  10;
    parameter IMG_WID  =  25;
    parameter EXP_CAM_SIZE        =  250;
    parameter EXP_BITTRAN_SIZE    =  250;
    parameter EXP_TXSP_SIZE       =  937;
    parameter DATA_MODE       =  2'b1;
    parameter DATA_SET        =  10;

    parameter IMG_ZISE = IMG_LEN * IMG_WID;
    parameter PACK2CELL_SIZE  =  20;
    parameter GVSP_STATUS     =  16'hfff3;
    parameter GVSP_MAC        =  16'h0800;
    parameter IP_S            =  32'h01234567;
    parameter IP_D            =  32'h89abcdef;
    parameter PORT_D          =  16'h1111;
    parameter PORT_S          =  16'hfff2;
    parameter BITTRAN_MODE    =  2;
    parameter MAC_S           =  48'haaa0_bbbb_cccc;
    parameter MAC_D           =  48'hfff0_8888_9999;
    parameter SD_CELL_NUM     =  128; //2nη
    parameter SD_CELL_LEN     =  3;
    parameter SD_DROP_TH      =  100;
    parameter SD_SEND_TH      =  10 ;


    


    parameter CYCLE       = 10   ;
    parameter PCLK_CYCLE  = 10   ;
    parameter RST_TIME    = 3    ;
    
    reg  [31:0]              rx_data;
    reg                      rx_vld ;
    reg                      rx_sop ;
    reg                      rx_eop ;
    reg  [ 1:0]              rx_mod ;
    wire                     rx_rdy ;               
   /*ģͲɼģĽӿ*/
    reg                      clk        ;
    reg                      rst_n      ;
    wire                     sclk       ;
    wire                     sdat       ;
    reg                      pclk       ;
    reg                      clk_96m    ;
    reg                      frame_valid;
    reg                      line_valid ;
    reg  [11:0]              data_in    ;
    
    /*sdramӿģӿ*/
    wire                     sdrammag_waddr_vld ;  
    wire[14:0]               sdrammag_waddr     ;  
    wire[15:0]               sdrammag_wdata     ;  
    wire                     sdrammag_wdata_vld ;  
    wire                     sdrammag_wdata_eoc ;  
    wire[15:0]               sdrammag_rdata_addr;  
    wire[15:0]               sdrammag_rdata_len ;  
    wire                     sdrammag_rdata_req ;  
    wire                     sdram_rdata_ack ;  
    wire                     sdrammag_rdata_rdy ;  
    wire[15:0]               sdram_rdata        ;  
    wire                     sdram_rdata_vld    ;  
    wire                     sdram_rdata_soc    ;  
    wire                     sdram_rdata_eoc    ; 
    wire                     sdrammag_txdata_rdy; 

    /*ģӿ*/
    wire[31:0]               tx_data       ;
    wire                     tx_sop        ;
    wire                     tx_eop        ; 
    wire                     tx_vld        ;
    reg                      tx_rdy        ;
    wire[1:0]                tx_mod        ;  
    wire                     tx_crc_fwd    ;    
    wire                     tx_err        ;  

    /*stm32ӿ*/
    wire                     stm_int      ;
    reg                      stm_rd       ;
    reg                      stm_wr       ;
    reg  [15:0]              stm_addr     ;
    reg  [15:0]              stm_wdata    ;
    wire [15:0]              stm_rdata    ;
    wire                     stm_rdata_vld;


    robot_icore  uut(
                    .clk                (clk                ),
                    .rst_n              (rst_n              ),
                    .rx_data            (rx_data            ),
                    .rx_vld             (rx_vld             ),
                    .rx_sop             (rx_sop             ),
                    .rx_eop             (rx_eop             ),
                    .rx_mod             (rx_mod             ),
                    .rx_rdy             (rx_rdy             ),
                                                            
                    .sclk               (sclk               ),
                    .sdat               (sdat               ),
                    .pclk               (pclk               ),
                    .clk_96m            (clk_96m            ),
                    .frame_valid        (frame_valid        ),
                    .line_valid         (line_valid         ),
                    .data_in            (data_in            ),
                     //SDRAMӿģ     //SDRAMӿģ
                    .sdrammag_waddr_vld (sdrammag_waddr_vld ),
                    .sdrammag_waddr     (sdrammag_waddr     ),
                    .sdrammag_wdata     (sdrammag_wdata     ),
                    .sdrammag_wdata_vld (sdrammag_wdata_vld ),
                    .sdrammag_wdata_eoc (sdrammag_wdata_eoc ),
                    //SDRAMӿģ()/SDRAMӿģ(
                    .sdrammag_rdata_addr(sdrammag_rdata_addr),
                    .sdrammag_rdata_len (sdrammag_rdata_len ),
                    .sdrammag_rdata_req (sdrammag_rdata_req ),
                    .sdrammag_rdata_ack (sdram_rdata_ack ),
                    .sdrammag_rdata_rdy (sdrammag_rdata_rdy ),
                    .sdram_rdata        (sdram_rdata        ),
                    .sdram_rdata_vld    (sdram_rdata_vld    ),
                    .sdram_rdata_soc    (sdram_rdata_soc    ),
                    .sdram_rdata_eoc    (sdram_rdata_eoc    ),
                    .sdrammag_txdata_rdy(sdrammag_txdata_rdy),
                                                            
                    //stm32Ľӿ     //stm32Ľӿ
                    .stm_int            (stm_int            ),
                    .stm_rd             (stm_rd             ),
                    .stm_wr             (stm_wr             ),
                    .stm_addr           (stm_addr           ),
                    .stm_wdata          (stm_wdata          ),
                    .stm_rdata          (stm_rdata          ),
                    .stm_rdata_vld      (stm_rdata_vld      ),
                                                            
                    .tx_data            (tx_data            ),
                    .tx_sop             (tx_sop             ),
                    .tx_eop             (tx_eop             ), 
                    .tx_vld             (tx_vld             ),
                    .tx_rdy             (tx_rdy             ),
                    .tx_mod             (tx_mod             ),  
                    .tx_crc_fwd         (tx_crc_fwd         ),    
                    .tx_err             (tx_err             )   
              );


              sdram_for_sim u_sdram_for_sim(
                      .clk         (clk         )   ,
                      .rst_n       (rst_n       )   ,
                      .waddr_vld   (sdrammag_waddr_vld   )   ,    
                      .waddr       (sdrammag_waddr       )   ,  
                      .wdata       (sdrammag_wdata       )   ,   
                      .wdata_vld   (sdrammag_wdata_vld   )   ,    
                      .wdata_eoc   (sdrammag_wdata_eoc   )   ,    
                      .rdata_addr  (sdrammag_rdata_addr  )   ,    
                      .rdata_len   (sdrammag_rdata_len   )   ,     
                      .rdata_req   (sdrammag_rdata_req   )   ,      
                      .rdata_ack   (sdram_rdata_ack   )   ,
                      .rdata       (sdram_rdata       )   ,    
                      .rdata_vld   (sdram_rdata_vld   )   ,        
                      .rdata_soc   (sdram_rdata_soc   )   ,     
                      .rdata_eoc   (sdram_rdata_eoc   )           
              );




            //ɱʱ50M
            initial begin
                clk = 0;
                forever
                #(CYCLE/2)
                clk=~clk;
            end

            initial begin
                pclk = 0;
                forever
                #(PCLK_CYCLE/2)
                pclk=~pclk;
            end
            initial begin
                #3;
                clk_96m = 0;
                forever
                #(PCLK_CYCLE/2)
                clk_96m=~clk_96m;
            end

            reg[11:0] cam_pkt     [IMG_ZISE*2-1:0];
            reg[15:0] bittran_pkt [IMG_ZISE*2-1:0];
            reg[15:0] txsp_pkt    [IMG_ZISE*2 + 1000-1:0];

            initial begin
                $readmemh("cam_data.txt", cam_pkt);          
                $readmemh("bittran_data.txt", bittran_pkt); 
                $readmemh("mac_data.txt",txsp_pkt);  
            end

            integer   cam_data_cnt = 0;
            integer   bittran_data_cnt = 0;
            integer   txsp_data_cnt = 0;


            always  @(posedge clk)begin
                if(uut.img_dout_vld)begin
                    if(uut.data_out !== cam_pkt[cam_data_cnt])
                        $display("Err at %0d,the %0d camera capture data is differ, exp=%0h,act=%0h",$time,cam_data_cnt,cam_pkt[cam_data_cnt],uut.data_out);
                    else
                        $display("Rig at %0d ,the %0d camera capture data is same, exp=%0h,act=%0h",$time,cam_data_cnt,cam_pkt[cam_data_cnt],uut.data_out);

                    cam_data_cnt <= cam_data_cnt + 1;
                end
            end

            always  @(posedge clk)begin
                if(uut.sdram_ctrl.bittran_dout_vld)begin
                    if(uut.sdram_ctrl.bittran_dout !== bittran_pkt[bittran_data_cnt])
                        $display("Err at %0d,the %0d bittran data is differ, exp=%0h,act=%0h",$time,bittran_data_cnt,bittran_pkt[bittran_data_cnt],uut.sdram_ctrl.bittran_dout);
                    else
                        $display("Rig at %0d,the %0d bittran data is same, exp=%0h,act=%0h",$time,bittran_data_cnt,bittran_pkt[bittran_data_cnt],uut.sdram_ctrl.bittran_dout);

                    bittran_data_cnt <= bittran_data_cnt + 1;
                end
            end


            always  @(posedge clk)begin
                if(uut.sdrammag_txdata_vld)begin
                    if(uut.sdrammag_txdata !== txsp_pkt[txsp_data_cnt])
                        $display("Err at %0d,the %0d sdram data is differ, exp=%0h,act=%0h",$time,txsp_data_cnt,txsp_pkt[txsp_data_cnt],uut.sdrammag_txdata);
                    else
                        $display("Rig at %0d,the %0d sdram data is same, exp=%0h,act=%0h",$time,txsp_data_cnt,txsp_pkt[txsp_data_cnt],uut.sdrammag_txdata);

                    txsp_data_cnt <= txsp_data_cnt + 1;
                end
            end

            

            //λź
            initial begin
                rst_n = 1;
                #2;
                rst_n = 0;
                #(CYCLE*RST_TIME);
                rst_n = 1;
            end

            initial begin
                tx_rdy = 1'b1;
            end

            reg[31:0]  checksum;

            initial begin
                stm_idle_task ;        
                #1;
                #(10 * CYCLE * RST_TIME);
                //òɼͼĳȷsop eop
                stm_write_task(MD_GAMMA_EN_ADDR,16'b1);    //٤ʹ
                stm_write_task(MT_IMG_COL_ADDR,IMG_WID);   //òɼģͼ
                stm_write_task(MT_IMG_ROW_ADDR,IMG_LEN);   //òɼģͼ

                stm_write_task(LOCAL_MAC0_ADDR ,(MAC_S>>32)&16'hffff);
                stm_write_task(LOCAL_MAC1_ADDR ,(MAC_S>>16)&16'hffff);
                stm_write_task(LOCAL_MAC2_ADDR ,(MAC_S>> 0)&16'hffff);
                stm_write_task(DEST_MAC0_ADDR  ,(MAC_D>>32)&16'hffff);
                stm_write_task(DEST_MAC1_ADDR  ,(MAC_D>>16)&16'hffff);
                stm_write_task(DEST_MAC2_ADDR  ,(MAC_D>> 0)&16'hffff);

                stm_write_task(LOCAL_IP0_ADDR,IP_S>>16     );
                stm_write_task(LOCAL_IP1_ADDR,IP_S & 16'hffff);

                stm_write_task(DEST_IP0_ADDR,IP_D>>16);
                stm_write_task(DEST_IP1_ADDR,IP_D & 16'hffff);
                
                stm_write_task(LOCAL_PORT_ADDR,PORT_S);
                stm_write_task(DEST_PORT_ADDR ,PORT_D);
                
                stm_write_task(MT_BITTRAN_MOD_ADDR ,BITTRAN_MODE);

                stm_write_task(SD_PACK2CELL_LEN_ADDR,PACK2CELL_SIZE);   //pack2cellģ飬GVSPдͼݵĸ
                stm_write_task(SD_GVSP_STATUS_ADDR  , GVSP_STATUS);//
                stm_write_task(SD_CELL_NUM_ADDR     , SD_CELL_NUM);//
                stm_write_task(SD_CELL_LEN_ADDR     , SD_CELL_LEN);//
                stm_write_task(SD_SEND_TH_ADDR      , SD_SEND_TH );//
                stm_write_task(SD_DROP_TH_ADDR      , SD_DROP_TH );//
                stm_write_task(SD_GVCP_MAC_TYPE_ADDR, GVSP_MAC);//


                checksum = 0;
                checksum = checksum + ((IP_S>>16)&16'hffff);
                checksum = checksum + ((IP_S>> 0)&16'hffff);
                checksum = checksum + ((IP_D>>16)&16'hffff);
                checksum = checksum + ((IP_D>> 0)&16'hffff);
                checksum = checksum + 16'd17;
                checksum = checksum + 16'd36;
                checksum = checksum + PORT_S;
                checksum = checksum + PORT_D;
                checksum = checksum + 16'd36;
                checksum = checksum + GVSP_STATUS;
                checksum = checksum + 16'h0100; //format
                checksum = checksum + 16'h0002; //type
                checksum = checksum + PACK2CELL_SIZE; //type

                checksum = (checksum[31:16] + checksum[15:0]);
                checksum = (checksum[31:16] + checksum[15:0]);
                $display("cfg_leader_checksum is %0h",checksum[15:0]);
                stm_write_task(SD_LEADER_CHECKSUM_ADDR, checksum[15:0]);//


                checksum = 0;
                checksum = checksum + ((IP_S>>16)&16'hffff);
                checksum = checksum + ((IP_S>> 0)&16'hffff);
                checksum = checksum + ((IP_D>>16)&16'hffff);
                checksum = checksum + ((IP_D>> 0)&16'hffff);
                checksum = checksum + 16'd17;
                checksum = checksum + 16'd20;
                checksum = checksum + PORT_D;
                checksum = checksum + PORT_S;
                checksum = checksum + 16'd20;
                checksum = checksum + GVSP_STATUS;
                checksum = checksum + 16'h0200; //format
                checksum = checksum + 16'h0002; //type

                checksum = (checksum[31:16] + checksum[15:0]);
                checksum = (checksum[31:16] + checksum[15:0]);
                $display("cfg_tail_checksum is %0h",checksum[15:0]);
                stm_write_task(SD_TAIL_CHECKSUM_ADDR  , checksum[15:0]);//


                checksum = 0;
                checksum = checksum + ((IP_S>>16)&16'hffff);
                checksum = checksum + ((IP_S>> 0)&16'hffff);
                checksum = checksum + ((IP_D>>16)&16'hffff);
                checksum = checksum + ((IP_D>> 0)&16'hffff);
                checksum = checksum + 16'd17;
                checksum = checksum + PORT_D;
                checksum = checksum + PORT_S;
                checksum = checksum + GVSP_STATUS;
                checksum = checksum + 16'h0300; //format

                checksum = (checksum[31:16] + checksum[15:0]);
                checksum = (checksum[31:16] + checksum[15:0]);
                $display("cfg_pay_checksum is %0h",checksum[15:0]);
                stm_write_task(SD_PAY_CHECKSUM_ADDR   , checksum[15:0]);//


                checksum = 0;
                checksum = checksum + 16'h4500;
                checksum = checksum + 16'h4000;
                checksum = checksum + 16'hff11;
                checksum = checksum + ((IP_S>>16)&16'hffff);
                checksum = checksum + ((IP_S>> 0)&16'hffff);
                checksum = checksum + ((IP_D>>16)&16'hffff);
                checksum = checksum + ((IP_D>> 0)&16'hffff);

                checksum = (checksum[31:16] + checksum[15:0]);
                checksum = (checksum[31:16] + checksum[15:0]);
                $display("cfg_ip_checksum is %0h",checksum[15:0]);
                stm_write_task(SD_IP_CHECKSUM_ADDR    , checksum[15:0]);//

                stm_idle_task;
            end

            integer  i,j;

            initial begin
                          //1        ֡϶     м϶    ̶    ģʽ00: all=data_set; 01:ÿؼ110ÿؼ1δ㡣11ÿһм1
                img_gen_task(IMG_WID,  IMG_LEN,  1000,       1000 ,    DATA_SET   ,       DATA_MODE );
                
            end

            initial begin
                #(FINISH_TIME*CYCLE);
                if(cam_data_cnt !==EXP_CAM_SIZE)begin
                    $display("Err,CAM number is error,exp=%0d,act=%0d",EXP_CAM_SIZE,cam_data_cnt);
                end
                if(bittran_data_cnt !==EXP_BITTRAN_SIZE)begin
                    $display("Err,BITTRAN number is error,exp=%0d,act=%0d",EXP_BITTRAN_SIZE,bittran_data_cnt);
                end
                if(txsp_data_cnt !==EXP_TXSP_SIZE)begin
                    $display("Err,SDRAM number is error,exp=%0d,act=%0d",EXP_TXSP_SIZE,txsp_data_cnt);
                end
                $stop;
            end

            
            `include "F:/svn/robot_project/trunk/code/test_icore/include/test_task/test_icore_task.v"


endmodule

