            task  stm_write_task;
                input[15:0]   addr;
                input[15:0]   data;

                begin
                    stm_rd = 0;
                    stm_wr = 1;
                    stm_addr  = addr;
                    stm_wdata = data;
                    #CYCLE;
                end
            endtask

            task  stm_idle_task;
                begin
                    stm_rd    = 0;
                    stm_wr    = 0;
                    stm_addr  = 0;
                    stm_wdata = 0;
                    #CYCLE;
                end
            endtask

            task  stm_read_task;
                input[15:0]   addr ;
                output[15:0]  rdata;

                begin
                    stm_rd = 0;
                    stm_wr = 0;
                    stm_addr  = addr;
                    stm_wdata = 0   ;
                    #CYCLE;
                    rdata = stm_rdata;
                end
            endtask

            task img_gen_task;
                input[15:0]   img_len;
                input[15:0]   img_wid;
                input[15:0]   fram_gap;
                input[15:0]   line_gap;
                input[15:0]   data_set;
                input[ 1:0]   data_mode;  //00: all=data_set; 01:ÿؼ110ÿؼ1δ㡣11ÿһм1  

                integer       zz,uu;

                begin
                    frame_valid  = 0;
                    line_valid   = 0;
                    data_in      = 0;
                    #(fram_gap*PCLK_CYCLE);
                    frame_valid  = 1;
                    for(zz=0;zz<img_wid;zz=zz+1)begin
                        #(line_gap*PCLK_CYCLE);
                        for(uu=0;uu<img_len;uu=uu+1)begin
                            line_valid   = 1;
                            data_in = (data_mode==2'b00)?data_set:(data_mode==2'b10)?uu:(data_mode==2'b01)?(zz*img_len+uu):zz;
                            #(PCLK_CYCLE);
                        end
                        line_valid = 0;
                        data_in    = 0;
                    end
                    frame_valid = 0;
                    #PCLK_CYCLE;
                end
            endtask
